package com.redhat.installer.asconfiguration.datasource.validator;
import com.izforge.izpack.installer.AutomatedInstallData;
import com.izforge.izpack.installer.ParameteredDataValidator;
import java.util.Map;
/**
 * Created by eunderhi on 03/06/15.
 * Takes two parameter keys and validates
 * that key1 is greater than key2
 */
public class GreaterThanDataValidator extends ParameteredDataValidator{

    String errorMessage;

    @Override
    public Status validateData(AutomatedInstallData adata) {
        Map<String, String> parameters = getParameters();

        String key1 = parameters.get("key1");
        String key2 = parameters.get("key2");
        String errorKey = parameters.get("error");

        int val1 = Integer.parseInt(adata.getVariable(key1));
        int val2 = Integer.parseInt(adata.getVariable(key2));
        errorMessage = adata.langpack.getString(errorKey);

        if(val1 < val2) {
            return Status.ERROR;
        }
        return Status.OK;
    }

    @Override
    public String getErrorMessageId() {
        return null;
    }

    @Override
    public String getWarningMessageId() {
        return null;
    }

    @Override
    public boolean getDefaultAnswer() {
        return false;
    }

    @Override
    public String getFormattedMessage() {
        return errorMessage;
    }
}

